#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>
#include <conio.h>

int pause(){
	printf("\nPresione una tecla para continuar...\n");
	getchar();
	return 0;
}
struct Tpuyo{//estructura para manejar el par de puyos que sabemos estan cayendo
	int x;
	int y;
	int falling;
};

struct TGame{
	public:
		int width;
		int height;
		int **arreglo;
		int speed;
		int falling;//es saber si algo esta cayendo
		struct Tpuyo puyo1,puyo2;
		TGame(){
			this->width=20;
			this->height=20;
			this->speed=200;
			this->falling=0;
			puyo1.falling=0;
			puyo2.falling=0;
			this->arreglo=(int**)malloc(sizeof(int*)*this->height);
			for(int i=0;i<this->height;i++){
				this->arreglo[i]=(int*)malloc(sizeof(int)*this->width);
			}
			for(int i=0;i<this->height;i++){
				for(int j=0;j<this->width;j++){
					this->arreglo[i][j]=0;
					if(i==0 || i==this->height-1 || j==0 || j==this->width-1){
						this->arreglo[i][j]=-1;
					}
				}
			}
			this->arreglo[0][(this->width)/2-1]=0;
			this->arreglo[0][(this->width)/2]=0;
		}
		~TGame(){
			for(int i=0;i<this->height;i++){
				free(this->arreglo[i]);
			}
			free(this->arreglo);
		}
		int display();
		int add_puyo();
		int check_falling();
		int check_lines();
		int update();
	private:
};
int TGame::display(){
	int i,j,aux;
	system("cls");
	printf("\n\t");
	aux=(this->width)/2-5;
	for(i=0;i<aux;i++){
		printf(" ");
	}
	printf("PUYO PUYO\n\n\n\t");
	for(i=0;i<this->height;i++){
		for(j=0;j<this->width;j++){
			if(this->arreglo[i][j]==0){
				printf(" ");
			}else if(this->arreglo[i][j]==-1){
				printf("#");
			}else if(this->arreglo[i][j]==1){
				printf("A");
			}else if(this->arreglo[i][j]==2){
				printf("B");
			}else if(this->arreglo[i][j]==3){
				printf("C");
			}else if(this->arreglo[i][j]==4){
				printf("D");
			}
		}
		printf("\n\t");
	}
}

int TGame::add_puyo(){
	this->arreglo[1][(this->width)/2-1]=rand()%4+1;
	this->arreglo[1][(this->width)/2]=rand()%4+1;
	this->puyo1.x=(this->width)/2-1;
	this->puyo1.y=1;
	this->puyo1.falling=1;
	this->puyo2.x=(this->width)/2;
	this->puyo2.y=1;
	this->puyo2.falling=1;
	return 0;
}

int TGame::check_lines(){

	return 0;
}

int TGame::check_falling(){
	return 0;
}

int TGame::update(){
	puyo1.falling=0;
	puyo2.falling=0;
	if(arreglo[puyo1.y+1][puyo1.x]==0){
		arreglo[puyo1.y+1][puyo1.x]=arreglo[puyo1.y][puyo1.x];
		arreglo[puyo1.y][puyo1.x]=0;
		puyo1.y=puyo1.y+1;
		puyo1.falling=1;
	}
	if(arreglo[puyo2.y+1][puyo2.x]==0){
		arreglo[puyo2.y+1][puyo2.x]=arreglo[puyo2.y][puyo2.x];
		arreglo[puyo2.y][puyo2.x]=0;
		puyo2.y=puyo2.y+1;
		puyo2.falling=1;
	}
	return 0;
}

int main(int argc, char *argv[]){
	int i,contador,limite,finish,score;
	double tiempo;
	time_t t_ini,t_fin;
	struct TGame juego;
	char tecla;
	srand(time(0));
	contador=0;
	limite=1000;
	finish=0;
	score=0;
	system("color F0");
	t_ini=clock();
	while(finish==0){
		while(!kbhit() && finish==0){
			if(juego.falling==0){
				juego.add_puyo();
				juego.falling=1;
			}else{

			}
			t_fin=clock();
			tiempo=(double)(t_fin-t_ini)/CLOCKS_PER_SEC;
			juego.display();
			printf("\n\t\t\t Tiempo: %lf\n",tiempo);
			Sleep(juego.speed);
			contador++;
			if(contador>limite){//opcional poner un limite de pasos(o tiempo)
				finish=1;
			}
			juego.update();
			/*while(juego.falling==1 && juego.puyo1.falling==0 && juego.puyo2.falling==0){//checa si algo cae pero no son puyos movibles
				juego.check_lines();//checar si se puede formar una linea vertical o horizontal de 4 y eliminar linea, pueden o no checar combos
				juego.check_falling();//checar si al eliminar lineas caen puyos, estos no se pueden mover
				juego.display();
				Sleep(juego.speed);
			}*/
			//if(juego.falling==0 && juego.puyo1.falling==0 && juego.puyo2.falling==0){
			if(juego.puyo1.falling==0 && juego.puyo2.falling==0){
				juego.add_puyo();
				juego.falling=1;
			}
		}
		if(finish==0){
			tecla=getch();//que tecleo el usuario
			if(tecla=='q'){
				finish=1;
			}
			if(tecla=='p'){
				pause();
			}
			if(tecla=='+' && juego.speed > 100){
				juego.speed-=100;
			}
			if(tecla=='-' && juego.speed < 10000){
				juego.speed+=100;
			}
			if(juego.falling==1){
				if(tecla=='a'){//mover puyos agregados que caen hacia la izquierda cuando se pueda
					if(juego.puyo1.falling==1){
						if(juego.arreglo[juego.puyo1.y][juego.puyo1.x-1]==0){
							juego.arreglo[juego.puyo1.y][juego.puyo1.x-1]=juego.arreglo[juego.puyo1.y][juego.puyo1.x];
							juego.arreglo[juego.puyo1.y][juego.puyo1.x]=0;
							juego.puyo1.x=juego.puyo1.x-1;
						}
					}
					if(juego.puyo2.falling==1){
						if(juego.arreglo[juego.puyo2.y][juego.puyo2.x-1]==0){
							juego.arreglo[juego.puyo2.y][juego.puyo2.x-1]=juego.arreglo[juego.puyo2.y][juego.puyo2.x];
							juego.arreglo[juego.puyo2.y][juego.puyo2.x]=0;
							juego.puyo2.x=juego.puyo2.x-1;
						}
					}
				}
				if(tecla=='d'){//mover puyos agregados que caen hacia la derecha cuando se pueda
					if(juego.puyo2.falling==1){
						if(juego.arreglo[juego.puyo2.y][juego.puyo2.x+1]==0){
							juego.arreglo[juego.puyo2.y][juego.puyo2.x+1]=juego.arreglo[juego.puyo2.y][juego.puyo2.x];
							juego.arreglo[juego.puyo2.y][juego.puyo2.x]=0;
							juego.puyo2.x=juego.puyo2.x+1;
						}
					}
					if(juego.puyo1.falling==1){
						if(juego.arreglo[juego.puyo1.y][juego.puyo1.x+1]==0){
							juego.arreglo[juego.puyo1.y][juego.puyo1.x+1]=juego.arreglo[juego.puyo1.y][juego.puyo1.x];
							juego.arreglo[juego.puyo1.y][juego.puyo1.x]=0;
							juego.puyo1.x=juego.puyo1.x+1;
						}
					}
				}
				if(tecla=='w'){//mover puyo derecho agregado hacia arriba, mover puyo arriba hacia la izquierda cuando se pueda

				}
				if(tecla=='s'){//acelerar descenso de puyo agregado

				}
			}
		}
	}
	return 0;
}
