#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <SDL/SDL.h>
//#include <SDL/SDL_ttf.h>

int main(int argc,char*argv[]){
	int i;
	SDL_Surface *screen,*image,*image_golpe;
	SDL_Rect origen[7],origen_golpe[12],dest,borrador,region_permitida;
	SDL_Event event;
	int done=0;
	srand(time(0));
	atexit(SDL_Quit);//le avisa que al terminar corra SDL_Quit
	// inicializamos video SDL
	if(SDL_Init(SDL_INIT_VIDEO)<0){//SDL_Init(Uint32 )
		printf("No pudo inicializar SDL: %s\n",SDL_GetError());
		return 1;
	}
	//ponemos titulo a la ventana
	SDL_WM_SetCaption( "Simulando movimiento parte 2", NULL );
	//Agregamos un icono a nuestra aplicacion
	SDL_WM_SetIcon(SDL_LoadBMP("icon.bmp"), NULL);
	//cargamos grafico
	image=SDL_LoadBMP("KOF02_Terry.bmp");
	image_golpe=SDL_LoadBMP("KOF02_Terry_02.bmp");
	//activamos modo de video
	screen = SDL_SetVideoMode(640,480,24,SDL_HWSURFACE);
	if(screen == NULL){
		fprintf(stderr, "No se puede establecer el modo de video 640x480: %s\n",SDL_GetError());
		return 1;
	}
	//definimos area de extraccion
	for(i=0;i<7;i++){
		origen[i].x = 0+i*125;
		origen[i].y = 0;
		origen[i].w = 125;
		origen[i].h = image->h;
	}
	//definimos area de dibujado
	dest.x = 100;
	dest.y = 100;
	dest.w = image->w;
	dest.h = image->h;
	//definimos area de borrado
	borrador.x = dest.x;
	borrador.y = dest.y;
	borrador.w = 125;
	borrador.h = origen[0].h;
	//vamos a crear transparencia
	SDL_SetColorKey(image, SDL_SRCCOLORKEY|SDL_RLEACCEL, SDL_MapRGB(image->format,143,123,165));
	SDL_FillRect( screen, &screen->clip_rect,SDL_MapRGB(screen->format,255,255,255));
	// Esperamos la pulsacin de una tecla para salir
	i=0;
	while(done == 0){
		//SDL_FillRect( screen, &screen->clip_rect,SDL_MapRGB(screen->format,255,255,255));
		SDL_FillRect( screen, &borrador,SDL_MapRGB(screen->format,255,255,255));
		SDL_BlitSurface(image, &origen[i], screen, &dest);
		// Mostramos la pantalla lo que esta en el buffer(EVITA PARPADEO)
		SDL_Flip(screen);
		i++;
		i=i%6;
		while(SDL_PollEvent(&event)){
			if(event.type == SDL_KEYDOWN){
				done = 1;
			}
		}
		SDL_Delay(100);
	}
	if(event.key.keysym.sym=='a'){
		//definimos area de extraccion
		for(i=0;i<12;i++){
			origen_golpe[i].x = 0+i*125;
			origen_golpe[i].y = 0;
			origen_golpe[i].w = 125;
			origen_golpe[i].h = 125;
		}
		//definimos area de dibujado
		dest.x = 100+i*30;
		dest.y = 100;
		dest.w = 125;
		dest.h = 125;
		//definimos area de borrado
		borrador.x = 100+(i-1)*30;
		borrador.y = 100;
		borrador.w = 125;
		borrador.h = 125;
		//vamos a crear transparencia
		SDL_SetColorKey(image_golpe, SDL_SRCCOLORKEY|SDL_RLEACCEL, SDL_MapRGB(image_golpe->format,143,123,165));
		for(i=0;i<12;i++){
			//actualizamos area de dibujado
			dest.x = 100+i*30;
			//actualizamos area de borrado
			borrador.x = 100+(i-2)*30;
			SDL_FillRect( screen, &borrador,SDL_MapRGB(screen->format,255,255,255));
			SDL_BlitSurface(image_golpe, &origen_golpe[i], screen, &dest);
			// Mostramos la pantalla lo que esta en el buffer(EVITA PARPADEO)
			SDL_Flip(screen);
			i++;
			SDL_Delay(100);
		}
	}
	SDL_Delay(1000);
	region_permitida.x=100;
	region_permitida.y=100;
	region_permitida.w=440;
	region_permitida.h=280;
	SDL_SetClipRect(screen,&region_permitida);
	for(i=1;i<=100;i++){
		// Ajustamos el canal alpha lo cual crea una imagen casi transparente
		SDL_SetAlpha(image,SDL_SRCALPHA|SDL_RLEACCEL,rand() % 255);
		// Definimos donde dibujaremos el grfico
		// y lo copiamos a la pantalla.
		dest.x = rand()%640;
		dest.y = rand()%480;
		dest.w = image->w;
		dest.h = image->h;
		SDL_BlitSurface(image, &origen[0], screen, &dest);
	}
	SDL_Flip(screen);
	done=0;
	while(done == 0){
		while(SDL_PollEvent(&event)){
			if(event.type == SDL_KEYDOWN){
				done = 1;
			}
		}
	}
	// liberar superficie
	SDL_FreeSurface(image);//libera memoria para imagen
	SDL_FreeSurface(image_golpe);//libera memoria para imagen
	SDL_FreeSurface(screen);//libera memoria para imagen
	return 0;
}
